// -*-C++-*-
/*!
 * @file  CameraInfoServiceSVC_impl.cpp
 * @brief Service implementation code of CameraInfoService.idl
 *
 */

#include "CameraInfoServiceSVC_impl.h"
#ifdef COIL_PROPERTIES_H
#define usleep(x) coil::usleep(x);
#endif

/*
 * Example implementational code for IDL interface CameraInfoService
 */
CameraInfoServiceSVC_impl::CameraInfoServiceSVC_impl():
_getIntrinsicLock(true),_getDistortionLock(true)
{
  // Please add extra constructor code here.
}


CameraInfoServiceSVC_impl::~CameraInfoServiceSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Boolean CameraInfoServiceSVC_impl::getIntrinsicParameter(CameraInfoService::IntrinsicParameter data)
throw (CORBA::SystemException)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Boolean CameraInfoServiceSVC_impl::getIntrinsicParameter(IntrinsicParameter data)>"
#endif
	// if this function is locked, it will wait until unlocking.
	while (_getIntrinsicLock){
		usleep(100);
	}

	// insert intrinsic parameter
	memcpy(data, _intrinsic, sizeof(double)*6);
  return 0;
}

CORBA::Boolean CameraInfoServiceSVC_impl::getDistortionParameter(CameraInfoService::DistortionParameter data)
throw (CORBA::SystemException)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Boolean CameraInfoServiceSVC_impl::getDistortionParameter(DistortionParameter data)>"
#endif
	// if this function is locked,  it will wait until unlocking.
	while (_getDistortionLock){
		usleep(100); 
	}

	// insert distortion parameter
	memcpy(data, _distortion, sizeof(double)*2);
  return 0;
}

/*
 * Example implementational code for IDL interface StereoCameraInfoService
 */
StereoCameraInfoServiceSVC_impl::StereoCameraInfoServiceSVC_impl():
_getExtrinsicLock(true)
{
  // Please add extra constructor code here.
}


StereoCameraInfoServiceSVC_impl::~StereoCameraInfoServiceSVC_impl()
{
  // Please add extra destructor code here.
}

CORBA::Boolean StereoCameraInfoServiceSVC_impl::getExtrinsicParameterBC( StereoCameraInfoService::ExtrinsicParameter data)
throw (CORBA::SystemException)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Boolean CameraInfoServiceSVC_impl::getDistortionParameter(DistortionParameter data)>"
#endif
	// if this function is locked,  it will wait until unlocking.
	while (_getExtrinsicLock){
		usleep(100); 
	}

	// insert distortion parameter
	memcpy(data, _extrinsic, sizeof(double)*12);
  return 0;
}
// End of example implementational code



