// -*-C++-*-
/*!
 * @file  ImageInfoServiceSVC_impl.cpp
 * @brief Service implementation code of ImageInfoService.idl
 *
 */

#include "ImageInfoServiceSVC_impl.h"
#ifdef COIL_PROPERTIES_H
#define usleep(x) coil::usleep(x);
#endif

/*
 * Example implementational code for IDL interface ImageInfoService
 */
ImageInfoServiceSVC_impl::ImageInfoServiceSVC_impl()
: _getImageWidthLock(true), _getImageHeightLock(true), _getPixelFormatLock(true)
{
  // Please add extra constructor code here.
}


ImageInfoServiceSVC_impl::~ImageInfoServiceSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Short ImageInfoServiceSVC_impl::getImageWidth()
throw (CORBA::SystemException)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Short ImageInfoServiceSVC_impl::getImageWidth()>"
#endif
	// if this function is locked, it will wait until unlocking.
	while (_getImageWidthLock){
		usleep(100);
	}

	// return width value
	//std::cout << "called service port's function \"getImageWidth()\"" << std::endl;
  return _width;
}

CORBA::Short ImageInfoServiceSVC_impl::getImageHeight()
throw (CORBA::SystemException)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Short ImageInfoServiceSVC_impl::getImageHeight()>"
#endif
	// if this function is locked, it will wait until unlocking.
	while (_getImageHeightLock){
		usleep(100);
	}

	// return height value
	//std::cout << "called service port's function \"getImageHeight()\"" << std::endl;
  return _height;
}

CORBA::Short ImageInfoServiceSVC_impl::getPixelFormat()
throw (CORBA::SystemException)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Short ImageInfoServiceSVC_impl::getPixelFormat()>"
#endif
	// if this function is locked, throw exception.
	while (_getPixelFormatLock){
		usleep(100);
	}

	// return pixel format
	//std::cout << "called service port's function \"getPixelFormat()\"" << std::endl;
  return _pixel;
}

// End of example implementational code
